###### _Readme out of date_

# JTC-Toastr _(1.0.2.3)_
**_A small JQuery-based plugin for creating Toast messages_**

## Building

#### Build using RequireJS's Optimizer, and Node.

_You need to have Node.js (and NPM) installed first._

Run: ``"node require.build.js -o require.config.js"`` in the terminal

This needs the RequireJS ``'r.js'`` file, any commands (e.g. ``'-o'``), and the build config file if desired.

## What to files to include

**This plugin requires jquery** (version 1.12 or higher) - not provided.

To use this plugin; you only need two files:
- ``jtc-toastr.min.js``
- ``jtc-toastr.min.css``

These files can be found in the ``'build'`` folder, in the repository.

Un-minified versions are also in this folder.

## How to use
To display a toast; you need to either create a trigger, or use the javascript function.

#### Using triggers

Create an element with the class "``toastr-trigger``".

Now add the attributes you want to use - there are three:

- ``data-toastr-message`` **required** {String} - Message to be displayed
- ``data-toastr-timeout`` {Number} (default: 5) - How long before the message is hidden (seconds) - set to ``-1`` to stop toast from hiding automatically
- ``data-toastr-showbar`` {Boolean} (default: false) - Whether to show timeout/loading bar

**_Example 1:_**
``<a class="toastr-trigger" data-toastr-message="The cake is a lie.">Fire when ready!</a>``

**_Example 2:_**
``<a class="toastr-trigger" data-toastr-message="Loading..." data-toastr-timeout="10" data-toastr-showbar="true">Show loading</a>``

**Demo:**
[CodePen example](https://codepen.io/joshdoescode/live/oLBPOa)

#### Using Javascript

The ``jtctoastr`` object is created by default when you include the JS file.

This object has two public functions:
- ``displayToast(message [, timeout, showTimeout])`` - used for displaying toasts messages
  - ``message`` {String} - The message to be displayed
  - ``timeout`` {Number, optional} (default: 5) - (Seconds) Time to wait before hiding message
  - ``showTimeout`` {Boolean, optional} (default: false) - Whether to show timeout/loading bar

**_displayToast() example 1:_**
``jtctoastr.displayToast("This website may or may not use cookies to do 'things'.");``

**_displayToast() example 2:_**
``jtctoastr.displayToast("This website may or may not use cookies to do 'things'.", 7, true);``

_All functions are documented using the JSDoc format._

#### Other Javascript functions

``{Number} getCounter()`` Return the number of toasts that have been created so far.

``{Number} getTotalHeightStack()`` Returns the total combined height of all currently displayed toast messages.

``{Boolean} isDebug()`` Returns the constant ``DEBUG`` - used to decide whether to show a lower level of log messages.

``{Boolean} hasStacktrace()`` Returns the contant ``STACKTRACE`` - used to decide whether to display a stacktrace with certain log messages.

## Limitations

_See 'Issues' in GitHub repository._

## Licence

The MIT License (MIT) - Copyright (c) 2016 Joshua Cain

